' Tree Sprite Generator
' Created by Jayenkai
' May 7th 2016

Global ScreenWidth=1024
Global ScreenHeight=512

Global TreeSize#=64	' Sprite size

Global ForceSeason=-1	' 0 = Spring
						' 1 = Summer
						' 2 = Autumn
						' 3 = Winter
						' Anything else (-1) for random seasons per tree

Global TreeStyle=-1		' 0 = Square trees
						' 1 = Rounded trees
						' 2 = Triangular trees
						' Anything else (-1) for randomly shaped trees

Global LeafThin=-1		' 0 = Tiny leaves
						' --vv--
						' 4 = Chunky leaves
						' Anything else (-1) for a random selection


Global LeafStyle=-1		' 0 = Circular leaves
						' 1 = Oval leaves
						' 2 = Angled Oval leaves
						' Anything else (-1) for a random selection

Graphics ScreenWidth,ScreenHeight,0
SeedRnd MilliSecs();For r=0 To 100;k=Rnd(0,10);Next



Cls
SetColor(255,0,255)
DrawRect(0,0,ScreenWidth,ScreenHeight)

For treeX=0 To ScreenWidth/TreeSize
For treeY=0 To ScreenHeight/TreeSize

	dx=treeX*TreeSize
	dy=treeY*TreeSize
	
	cx=(treeX*TreeSize)+(TreeSize/2)
	cy=(treeY*TreeSize)+(TreeSize/2)

	SetViewport dx,dy,TreeSize,TreeSize
	
	' Trunk and Stump
	SetColor(Rnd(60,80),Rnd(30,50),0)
		' Trunk
		' Size
	ThinTrunk=Float(TreeSize)*0.05
	ThickTrunk=Float(TreeSize)*0.1
	If ThinTrunk<3 Then ThinTrunk=3
	If ThickTrunk<ThinTrunk+2 Then ThickTrunk=ThinTrunk+2
	thick=Rand(ThinTrunk,ThickTrunk)
	
	DrawRect(cx-thick,cy,thick*2,((TreeSize/2)-4))
		' Stumpy bits
		
	Splots=16
	If TreeSize>64 Then Splots=20
	If TreeSize>96 Then Splots=24
	
	For n=0 To Splots
		w=Rand(ThinTrunk,ThickTrunk)
		DrawOval((cx+Rand(-n/2,n/2))-w,((cy+(TreeSize/2))-(4+Splots))+(n),w*2,Rand(ThinTrunk,ThickTrunk))
	Next

	' Leaves

	LeafSize=LeafThin
	If LeafThin<0 Or LeafThin>4 Then LeafSize=Rand(0,4)
	
	LeafBig=(TreeSize/80.0)*Float(LeafSize+1)
	LeafLittle=(TreeSize/120.0)*Float(LeafSize+1)	
	
	Bushy=Rand((TreeSize/4),(TreeSize/2)-LeafBig)
	Shape=Rand(0,2)
	If TreeStyle>-1 And TreeStyle<3 Then Shape=TreeStyle
	
	
	AngleThese=LeafStyle
	If LeafStyle>-1 Or LeafStyle<3 Then AngleThese=AngleLeaves
	
	Darker=Rand(-50,50)
	Season=Rand(0,3)
	If ForceSeason>-1 And ForceSeason<4 Then Season=ForceSeason

	For LeafLayer=1 To 3
		LayerY=(((4-LeafLayer)*(TreeSize*0.2)))+4
		deep=TreeSize/16.0
		If deep<2 Then deep=2

		LayerY=LayerY+Rand(-deep,deep)
		If LayerY<8 Then LayerY=8
		If LayerY>(TreeSize*0.75) Then LayerY=(TreeSize*0.75)
		LayerY=LayerY
		
		leaves=bushy*10

		For Leaf=0 To leaves

			' Color of Leaf
			shade=Rand(-3,4)*8
			Select Season
				Case 2	' Autumn
					r=(LeafLayer*70)+Shade
					g=(LeafLayer*40)+Shade
					b=(LeafLayer*20)+Shade
				Case 3	' Winter
					r=(LeafLayer*70)+Shade
					g=(LeafLayer*60)+Shade
					b=(LeafLayer*50)+Shade
					If Rand(0,5)<3
						r=(LeafLayer*70)+Shade
						g=(LeafLayer*70)+Shade
						b=(LeafLayer*70)+Shade
					EndIf

				Case 1	' Summer
					r=(LeafLayer*10)+Shade
					g=(LeafLayer*70)+Shade
					b=(LeafLayer*10)+Shade

					
				Default	' Standard
					r=(LeafLayer*30)+Shade
					g=(LeafLayer*70)+Shade
					b=(LeafLayer*30)+Shade
			End Select
			r=r+Darker
			g=g+Darker
			b=b+Darker
			If r<0 Then r=0
			If r>255 Then r=255
			If g<0 Then g=0
			If g>255 Then g=255
			If b<0 Then b=0
			If b>255 Then b=255
			SetColor(r,g,b)

			' Position of Leaf
			If LeafLittle<1 Then LeafLittle=1;LeafBig=2


				LeafW#=(Rnd(LeafLittle,LeafBig))
				LeafH#=(Rnd(LeafLittle,LeafBig))
			If AngleThese=0 Then LeafH=LeafW
			If AngleThese=2
				LeafW#=(Rnd(LeafLittle,LeafBig))*0.75
				LeafH#=(Rnd(LeafLittle,LeafBig))*1.25
			EndIf
			
			
			
			LeafX#=(Rand(-Bushy,Bushy))
			LeafY#=(LayerY+Rand(-Bushy*0.5,Bushy*0.5))

			Select Shape 
				Case 0	' Square - Maybe use this to round off the edges so they aren't "too" square..?  Can't be arsed doing that..
			
				Case 1	' Rounded - A ball of leaves!
					LeafMidPoint=(TreeSize*0.45)
					Angle#=ATan2(LeafX,LeafMidpoint-LeafY)
					Dist#=Sqr(((LeafX)*(LeafX))+((LeafY-LeafMidpoint)*(LeafY-LeafMidpoint)))
					If Dist>bushy Then Dist=bushy
					LeafX=(Sin(Angle)*Dist)
					LeafY=LeafMidpoint-(Cos(Angle)*Dist)
			
				Case 2	' Triangular - Thinner at the top
					WideAllow=(Float(LeafY)/Float(Float(Bushy)*2.5))*Float(Bushy*1)
					If WideAllow<2 Then WideAllow=2
					If WideAllow>Bushy Then WideAllow=Bushy
					LeafX=Rand(-WideAllow,WideAllow)
			End Select
			
			' Draw the leaf
			If AngleThese=2 Then SetRotation(Rand(-25,25))
			DrawOval((cx+LeafX)-LeafW,(dy+LeafY)-LeafH,LeafW*2,LeafH*2)
		Next
	Next
SetRotation(0)
SetViewport 0,0,512,512
Flip
Next
Next

outimg:TPixmap=GrabPixmap(0,0,ScreenWidth,ScreenHeight)
For x=0 To ScreenWidth-1
For y=0 To ScreenHeight-1
argb=ReadPixel(outimg,x,y)
If (argb & $00FFFFFF)=$00FF00FF Then argb=$00000000
WritePixel(outimg,x,y,argb)
Next
Next
SavePixmapPNG(outimg,"Trees.png")

